///////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky - Happy New Year sreen saver
//
// ScreenSaverProc function implementation
//

#include "stdlib.h"
#include "time.h"
//#include "stdafx.h"
#include "windows.h"
#include "winuser.h"
#include "scrnsave.h"
#include "resource.h"
#include "Happy New Year.h"
#include "PaletteFromBmp.h"

#define snow_flake_NUMBER 300
#define SNOW_FLAKE_MAX_OFFSET 4
//int i = 0;

DWORD snow_flakeFallingThread( LPVOID data );

DWORD snow_flakeFallingThreadID;
HANDLE hsnow_flakeFallingThread;

BOOL stillRunning;
//BOOL snow_flakeFalled;

BOOL saverMode;
//HWND hWnd;
//extern HANDLE hMainInstance;
//extern HWND hMainWindow;
//HANDLE hMainInstance;
//HWND hMainWindow;
//extern TCHAR  szName[TITLEBARNAMELEN];
HPALETTE hPalette;
HBITMAP hOldBitmap;

COLORREF blackColor = RGB(0,0,0),
		 whiteColor = RGB(255,255,255);

int maxScreen_x, maxScreen_y;
BITMAP tree;
RECT rcTree;
//LOGPALETTE *PLogPalette;
//HDC hDC;
//HDC hDc;

struct _snow_flake 
{
  int x, y, lastPosition, lastX;
  COLORREF backColor;
  int factor, offset;
} snow_flake[2][snow_flake_NUMBER];


LRESULT WINAPI ScreenSaverProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
static HDC          hdc, hDC, hMemDC;    /* device-context handle */ 
static HBITMAP hTree, hCandle, hFire;//, hNYTree;
static BITMAP bmpCandle, bmpFire;
static RECT         rc;     /* RECT structure */ 
static UINT         uTimer1; /* timer identifier */ 
static int fireNumber, fireX, fireX2, fireY;
char txt[100];

// const NumEntries = 236;
// PAINTSTRUCT PaintStruct;
// RECT Rect, ClientRect;
// HDC hDC;
// HBRUSH hBrush;
// LOGPALETTE *PLogPalette;
// int i, j;
//static HDC hMemDC;
//static
PAINTSTRUCT ps;
 
    switch(message) 
    { 
	/////////////////////////////////////////////////////////////////
	// WM_CREATE

		case WM_CREATE: 

			maxScreen_x = GetSystemMetrics(SM_CXFULLSCREEN);
			maxScreen_y = GetSystemMetrics(SM_CYFULLSCREEN);

			///////////////////////////////////////////////////////////
			//    ,     Screen Poperties
/*			GetClientRect( hwnd, &rc );
			if( (rc.right - rc.left) < 160 )
			{
				saverMode = FALSE;
			}
			else
				saverMode = TRUE;
				*/

			///////////////////////////////////////////////////////////////
			//     Preview
			GetWindowText( hwnd, txt, 50);
			if( strcmp( txt, "Preview" ) == 0 )
				saverMode = FALSE;
			else
				saverMode = TRUE;
				


//			hWnd = hwnd;
//			HDC hdc = GetDC(hwnd);
			if( saverMode )
			{
			if( maxScreen_x < 780 )
			{
				DestroyWindow( hwnd );
				return FALSE;
			}

/*   {
   HBITMAP hBitmap,hOldBitmap;
   HPALETTE hPalette;
   HDC hMemDC, hdc;
   BITMAP bm;
 
   hBitmap = LoadResourceBitmap(hInst,"test", &hPalette);
   GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
   hdc = GetDC(hWnd);
   hMemDC = CreateCompatibleDC(hdc);
   SelectPalette(hdc,hPalette,FALSE);
   RealizePalette(hdc);
   SelectPalette(hMemDC,hPalette,FALSE);
   RealizePalette(hMemDC);
   hOldBitmap = SelectObject(hMemDC,hBitmap);
   BitBlt(hdc,0,0,bm.bmWidth,bm.bmHeight,hMemDC,0,0,SRCCOPY);
   DeleteObject(SelectObject(hMemDC,hOldBitmap));
   DeleteDC(hMemDC);
   ReleaseDC(hWnd,hdc);
   DeleteObject(hPalette);
   }
*/
	{
		LPLOGPALETTE     lpPal;
	   HANDLE           hLogPal;
   HPALETTE         hPal = NULL;

       hdc = GetDC(NULL);
       hLogPal = GlobalAlloc (GHND, sizeof (LOGPALETTE) +
                             sizeof (PALETTEENTRY) * (236));
      lpPal = (LPLOGPALETTE) GlobalLock (hLogPal);
      lpPal->palVersion    = 0x300;
      lpPal->palNumEntries = 236;
 
      for (int i = 0;  i < 236 ;  i++)
         {

         lpPal->palPalEntry[i].peRed   = i;
         lpPal->palPalEntry[i].peGreen = i;
         lpPal->palPalEntry[i].peBlue  = i;
         lpPal->palPalEntry[i].peFlags = 0;
/*
         lpPal->palPalEntry[i].peRed   = 2 * i;
         lpPal->palPalEntry[i].peGreen = i;
         lpPal->palPalEntry[i].peBlue  = 4 * i;
         lpPal->palPalEntry[i].peFlags = 0;
  */
		}

      hPal = CreatePalette (lpPal);
      GlobalUnlock (hLogPal);
      GlobalFree   (hLogPal);

       if (hPal)
       {
	      SelectPalette(hdc,hPal,FALSE);
          RealizePalette(hdc);
       }
	  }

/*
			hTree = LoadBitmap((HINSTANCE)hMainInstance,
										MAKEINTRESOURCE(IDB_TREE));
*/
			hTree = LoadBitmap((HINSTANCE)hMainInstance,
										MAKEINTRESOURCE(IDB_TREE));//, &hPalette);

//			hTree = LoadImage((HINSTANCE)hMainInstance,MAKEINTRESOURCE(IDB_TREE),
//							  IMAGE_BITMAP, 700,500, LR_LOADMAP3DCOLORS|COLOR_3DFACE );

			GetObject( hTree, sizeof(BITMAP), &tree);
/*
			hNYTree = LoadBitmap((HINSTANCE)hMainInstance,
										MAKEINTRESOURCE(IDB_NEWYEARTREE));
*/
			///////////////////////////////////////////////
			// Candles
			hCandle = LoadBitmap((HINSTANCE)hMainInstance,
										MAKEINTRESOURCE(IDB_CANDLE));
			GetObject( hCandle, sizeof(BITMAP), &bmpCandle);


			////////////////////////////////////////////////
			// Fires
			fireNumber = 1;
			hFire = LoadBitmap((HINSTANCE)hMainInstance,
										MAKEINTRESOURCE(IDB_FIRE));
			GetObject( hFire, sizeof(BITMAP), &bmpFire);


			rcTree.left = (maxScreen_x - tree.bmWidth) / 2;
			rcTree.top = (maxScreen_y - tree.bmHeight) / 2;
			rcTree.bottom = rcTree.top + tree.bmHeight; 
			rcTree.right = rcTree.left + tree.bmWidth; 


//			stillRunning = TRUE;

			hsnow_flakeFallingThread = CreateThread(NULL, 0,
						 (LPTHREAD_START_ROUTINE)snow_flakeFallingThread,
						 (LPVOID)NULL, CREATE_SUSPENDED, &snow_flakeFallingThreadID);
//			SetThreadPriority( hsnow_flakeFallingThread, THREAD_PRIORITY_HIGHEST);
 

//			hDc = GetDC(hwnd);

			// Timers snow_flaketing
            uTimer1 = SetTimer(hwnd, 1, 100, NULL); 
//            uTimer2 = SetTimer(hwnd, 2, 0, NULL); 

			}
            break; 

	/////////////////////////////////////////////////////////////////
	// WM_PAINT

		case WM_PAINT:
/*
			GetClientRect( hwnd, &rc );
			if( (rc.right - rc.left) < 160 )
			{
				saverMode = FALSE;
			}
			else
				saverMode = TRUE;
*/			
			if( saverMode )
			{
            hdc = BeginPaint(hwnd, &ps); 
/*
			for( n = 0; n < maxScreen_y / 2; n++ )
			{
				MoveTo( hdc, 1, n, NULL );
				LineTo( hdc, maxScreen_x, n );
			}*/
///			SetICMMode( hdc, ICM_ON );

			hMemDC = CreateCompatibleDC( hdc );

		    SelectPalette(hdc,hPalette,TRUE);
		    RealizePalette(hdc);
			
			SelectPalette(hMemDC,hPalette,TRUE);
			RealizePalette(hMemDC);

			hOldBitmap = (HBITMAP) SelectObject(hMemDC, hTree);

			BitBlt(hdc, rcTree.left, rcTree.top,
			 	    tree.bmWidth, tree.bmHeight, hMemDC, 0, 0, SRCCOPY);
		 
//			DeleteObject(SelectObject(hMemDC,hOldBitmap));

/*  for(i = 0; i < 256; i++)
  {
   hBrush = CreateSolidBrush(0x01000000 + i);
   Rect.left = ((ClientRect.right - ClientRect.left) / 18) +
               i % 8 * ((ClientRect.right - ClientRect.left) / 9);
   Rect.top = ((ClientRect.bottom - ClientRect.top) / 72) +
              i / 8 % 32 * ((ClientRect.bottom - ClientRect.top) / 36);
   Rect.right = Rect.left + ((ClientRect.right - ClientRect.left) / 9);
   Rect.bottom = Rect.top + ((ClientRect.bottom - ClientRect.top) / 36);
   FillRect(hdc, &Rect, hBrush);
   DeleteObject(hBrush);
  }

			StretchBlt( hdc, rcTree.left, rcTree.top,
			 	    tree.bmWidth, tree.bmHeight,
					hMemDC, 0, 0, tree.bmWidth, tree.bmHeight, SRCCOPY);
*/
//		    DeleteObject(hTree);
/*
			SelectObject(hMemDC, hNYTree);

			BitBlt(hdc, rcTree.left + 202, rcTree.top - 257 + 46 ,
			 	    184, 257, hMemDC, 0, 0, SRCCOPY);
		    DeleteObject(hNYTree);
*/			///////////////////////////////////////////////
			// Candles

			SelectObject(hMemDC, hCandle);

			fireX = rcTree.left - bmpCandle.bmWidth - 10;
			fireX2 = rcTree.right + 10;
			fireY = rcTree.bottom - bmpCandle.bmHeight;
 
			BitBlt(hdc,fireX, fireY,
				   bmpCandle.bmWidth, bmpCandle.bmHeight, hMemDC, 0, 0, SRCCOPY);
			BitBlt(hdc,fireX2, fireY, bmpCandle.bmWidth,
				   bmpCandle.bmHeight, hMemDC, 0, 0, SRCCOPY);

//			DeleteObject(hCandle);

			////////////////////////////////////////////////
			// Fires
			fireY -= 44;
			fireX += 10;
			fireX2 += 10;
//			SelectObject( hMemDC, hFire );

			//HPEN pen = CreatePen(PS_SOLID,1,RGB(255,0,0));
			//SelectObject( hdc, pen );
	
			///////////////////////////////////////////////
			// Create new font for Year

			HFONT font = CreateFont(72,0,0,0,FW_BOLD,
									TRUE,0,0,DEFAULT_CHARSET,
									OUT_DEFAULT_PRECIS,
									CLIP_DEFAULT_PRECIS,
									DEFAULT_QUALITY,
									DEFAULT_PITCH | FW_DONTCARE,
									"Times New Roman");

			SetBkColor( hdc, RGB(0,0,230));
			SetTextColor( hdc, RGB(230,230,230));

			SelectObject( hdc, font);

			////////////////////////////////////////////////
			// Get system time and current year number

			SYSTEMTIME sysTime;
//			char phrase1[] = {"  "};
//			char phrase2[] = {" !"};
			char year[5];

			GetSystemTime( &sysTime );

			if( sysTime.wMonth == 12 )	sysTime.wYear++;

			itoa(sysTime.wYear, year, 10);

//			strcat( phrase1, year );
//			strcat( phrase1, phrase2 );

			TextOut(hdc, rcTree.left + 253,
						 rcTree.top + 8, year, 4);

			//			if( font == NULL )
//				return FALSE;

//			DeleteObject( pen );
			DeleteObject(font);

			///////////////////////////////////////////////////////
			 //  
			ResumeThread(hsnow_flakeFallingThread);

		//  if(!
//			DeleteObject(hPalette);
//			 )
//			ErrorMessage("DeleteObject Error");
//			LocalFree(PLogPalette);

            DeleteDC(hMemDC); 
			EndPaint( hwnd, &ps);
//			DeleteObject(hTree);
			}
			else
			{
			 hDC = GetDC( hwnd );
			 hMemDC = CreateCompatibleDC( hDC );
//			 DeleteDC( hMemDC );
//			 ReleaseDC( hwnd, hdc );

             GetClientRect (hwnd, &rc); 
			 HBITMAP hPic = LoadBitmap((HINSTANCE)hMainInstance,
			 							MAKEINTRESOURCE(IDB_PICTURE));
			 SelectObject( hMemDC, hPic );

			 BitBlt(hDC, rc.left + 38, rc.top,
			 	    75, 112, hMemDC, 0, 0, SRCCOPY);

			 DeleteObject(hPic);


			 ReleaseDC( hwnd, hDC );
			 return FALSE;
			}
//			if( saverMode ) ResumeThread(hsnow_flakeFallingThread)
			break;
 
	/////////////////////////////////////////////////////////////////
	// WM_ERASEBKGND

        case WM_ERASEBKGND: 
            hDC = GetDC(hwnd); 
			if( saverMode )
			{
             GetClientRect (hwnd, &rc); 
/*			 HBITMAP hPic = LoadBitmap((HINSTANCE)hMainInstance,
			 							MAKEINTRESOURCE(IDB_PICTURE));
			 SelectObject( hMemDC, hPic );

			 BitBlt(hdc, rc.left, rc.top,
			 	    155, 116, hMemDC, 0, 0, SRCCOPY);

			 DeleteObject(hPic);*/
             FillRect (hDC, &rc, (HBRUSH) GetStockObject(BLACK_BRUSH)); 
			}
            ReleaseDC(hwnd,hDC); 
            break; 
 
	/////////////////////////////////////////////////////////////////
	// WM_TIMER

		case WM_TIMER: 

            hdc = GetDC(hwnd); 

			hMemDC = CreateCompatibleDC( hdc );
			SelectObject( hMemDC, hFire );

			/////////////////////////////////////////////////////////////////
			//   -  .
 			 if( fireNumber < 3 )
		 		 fireNumber++;
 			 else
				 fireNumber = 1;

		     switch( fireNumber )
			 {
		      case 1:
				  BitBlt(hdc, fireX, fireY, 30, 45, hMemDC, 0, 0, SRCCOPY);
   				  BitBlt(hdc, fireX2, fireY, 30, 45, hMemDC, 30, 0, SRCCOPY);
				  break;

		      case 2: 
				  BitBlt(hdc, fireX, fireY, 30, 45, hMemDC, 30, 0, SRCCOPY);
              	  BitBlt(hdc, fireX2, fireY, 30, 45, hMemDC, 0, 0, SRCCOPY);
              	  break;

		      case 3: 
				  BitBlt(hdc, fireX, fireY, 30, 40, hMemDC, 60, 0, SRCCOPY);
              	  BitBlt(hdc, fireX2, fireY, 30, 40, hMemDC, 60, 0, SRCCOPY);
				  break;
			 }

			DeleteDC(hMemDC); 
            ReleaseDC(hwnd,hdc); 
			break;
 
        case WM_DESTROY: 
 
           /* 
            * When the WM_DESTROY message is issued, the screen saver 
            * must destroy any of the timers that were set at WM_CREATE 
            * time. 
            */ 
			if( saverMode )
			{
//			    ReleaseDC(hMainWindow, hDc); 

				//////////////////////////////////////////////////////////
				//       
				DWORD exitResult;
				while( GetExitCodeThread( hsnow_flakeFallingThread, &exitResult ) == STILL_ACTIVE)
					stillRunning = FALSE;
//				ExitThread(

//				ExitThread( snow_flakeFallingThreadID );
	
				if( hFire )
					DeleteObject( hFire );

				DeleteDC( hMemDC );
			    DeleteObject(hPalette);
			 
            if (uTimer1) 
                KillTimer(hwnd, uTimer1); 

/*            if (uTimer2) 
                KillTimer(hwnd, uTimer2); 
*/
//				DeleteObject(hPalette);
//				LocalFree(PLogPalette);
			}
            break; 

/*
		case WM_ACTIVATEAPP:
			GetWindowText( hwnd, txt, 50);
			if( strcmp( txt, "Preview" ) == 0 )
				saverMode = FALSE;
			else
				saverMode = TRUE;
			break;
*/			/*
		case WM_SHOWWINDOW:
			GetWindowText( hwnd, txt, 50);
			if( strcmp( txt, "Preview" ) == 0 )
				saverMode = FALSE;
			else
				saverMode = TRUE;

            hdc = GetDC(hwnd); 
			if( !saverMode )
			{
             GetClientRect (hwnd, &rc); 
			 HBITMAP hPic = LoadBitmap((HINSTANCE)hMainInstance,
			 							MAKEINTRESOURCE(IDB_PICTURE));
			 SelectObject( hMemDC, hPic );

			 BitBlt(hdc, rc.left, rc.top,
			 	    155, 116, hMemDC, 0, 0, SRCCOPY);

			 DeleteObject(hPic);
//             FillRect (hdc, &rc, (HBRUSH) GetStockObject(BLACK_BRUSH)); 
			}
            ReleaseDC(hwnd,hdc); 
			break;*/
    } 
 
   /* 
    * DefScreenSaverProc processes any messages 
    * ignored by ScreenSaverProc. 
    */ 
 
    return DefScreenSaverProc(hwnd, message, wParam, lParam); 
} 


DWORD snow_flakeFallingThread( LPVOID data )
{
 int n,j;
 int level = 0;
 HDC hdc;
 DWORD maxTick;

			/////////////////////////////////////////////////////////////////////////
			// snow_flake objects initialization

			srand( (unsigned)time( NULL ) ); 

			for( j = 0; j < 2; j++)
	 			for(n = 0; n < snow_flake_NUMBER; n++)
				{
//				srand( (unsigned)time( NULL ) ); 

			     snow_flake[j][n].x = rand() % (tree.bmWidth - SNOW_FLAKE_MAX_OFFSET) + rcTree.left + SNOW_FLAKE_MAX_OFFSET;
 				 snow_flake[j][n].y = rcTree.top + rand() % tree.bmHeight ;
				 snow_flake[j][n].backColor = blackColor;
				 snow_flake[j][n].lastPosition = snow_flake[j][n].lastX = 0;
//			srand( (unsigned)time( NULL ) ); 
				 snow_flake[j][n].factor = rand() % SNOW_FLAKE_MAX_OFFSET - 2;
				 snow_flake[j][n].offset = 0;
				}

 hdc = GetDC( hMainWindow );
 SelectPalette(hdc,hPalette,TRUE);
 RealizePalette(hdc);

 //snow_flakeFalled = FALSE;
 stillRunning = TRUE;

 while( stillRunning )
 {

	 ////////////////////////////////////////////////////////////
	 //     
	 maxTick = GetTickCount() + 5;
	 while( GetTickCount() < maxTick );

	for(j = 0;j < (level ? 1 : 2) ; j++)
	{
   		for(n = 0;n < snow_flake_NUMBER;n++)
		{
			if(snow_flake[level][n].y < ( rcTree.bottom - 15 )) 
			{
				snow_flake[level][n].y += 2;

				if( abs(snow_flake[level][n].offset) > SNOW_FLAKE_MAX_OFFSET )
				{
					snow_flake[level][n].factor = -snow_flake[level][n].factor;
				}
				snow_flake[level][n].offset += snow_flake[level][n].factor;

				snow_flake[level][n].x += snow_flake[level][n].factor ;
			}
			else
				snow_flake[level][n].y = rcTree.top + 2;

			////////////////////////////////////////////////////////////
			//    :-)
			if( snow_flake[level][n].backColor != whiteColor )
			{
				   SetPixel(hdc,snow_flake[level][n].lastX, snow_flake[level][n].lastPosition,snow_flake[level][n].backColor);
			}

		    snow_flake[level][n].backColor = GetPixel(hdc,snow_flake[level][n].x,snow_flake[level][n].y);

			SetPixel(hdc,snow_flake[level][n].x,snow_flake[level][n].y,whiteColor);

			snow_flake[level][n].lastPosition = snow_flake[level][n].y;
			snow_flake[level][n].lastX = snow_flake[level][n].x;
		}
    }
	level = level ? 0 : 1;
 }

 ReleaseDC( hMainWindow, hdc );

// snow_flakeFalled = TRUE;
 return 0;
}


///////////////////////////////////////////////////////////////////////////////
// Evgeny Savitsky
// 

